package dev.fyloz.trial.colorrecipesexplorer.core.exception.model;

import dev.fyloz.trial.colorrecipesexplorer.core.model.IModel;
import org.hibernate.type.IdentifierType;

/**
 * Représente une exception qui sera lancée lorsqu'un objet du modèle n'est pas trouvé.
 */
public class EntityNotFoundException extends ModelException {

    /**
     * Le type d'identifiant utilisé
     */
    private IdentifierType identifierType;

    /**
     * La valeur de l'identifiant
     */
    private Object requestedId;

    public EntityNotFoundException(Class<? extends IModel> type, IdentifierType identifierType, Object requestedId) {
        super(type);
        this.identifierType = identifierType;
        this.requestedId = requestedId;
    }

    public IdentifierType getIdentifierType() {
        return identifierType;
    }

    public Object getRequestedId() {
        return requestedId;
    }

}
