package dev.fyloz.trial.colorrecipesexplorer.core.exception.model;

import dev.fyloz.trial.colorrecipesexplorer.core.model.IModel;

/**
 * Représente une exception qui sera déclenchée lors des opérations sur le modèle.
 */
public class ModelException extends RuntimeException {

    /**
     * Le type de modèle qui est sujette à l'exception
     */
    protected Class<? extends IModel> type;

    public ModelException(Class<? extends IModel> type) {
        this.type = type;
    }

    public Class<? extends IModel> getType() {
        return type;
    }

    public enum IdentifierType {
        ID("id"),
        NAME("name"),
        OTHER("");

        private String name;

        IdentifierType(String name) {
            this.name = name;
        }

        public String getName() {
            return name;
        }
    }
}
