package dev.fyloz.trial.colorrecipesexplorer.core.services;

import dev.fyloz.trial.colorrecipesexplorer.core.utils.PdfBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.ResourceLoader;
import org.springframework.stereotype.Service;

import java.io.IOException;

@Service
public class TouchUpKitService {

    private static final String TOUCH_UP_FR = "KIT DE RETOUCHE";
    private static final String TOUCH_UP_EN = "TOUCH UP KIT";
    public static final int FONT_SIZE = 42;

    private ResourceLoader resourceLoader;

    @Autowired
    public TouchUpKitService(ResourceLoader resourceLoader) {
        this.resourceLoader = resourceLoader;
    }

    public byte[] getPdfForJobNumber(String jobNumber) throws IOException {
        return new PdfBuilder(resourceLoader, true, FONT_SIZE)
                .addLine(TOUCH_UP_FR, true, 0)
                .addLine(TOUCH_UP_EN, true, 0)
                .addLine(jobNumber, false, 10)
                .build();
    }

}
