package dev.fyloz.trial.colorrecipesexplorer.core.services.files;

import dev.fyloz.trial.colorrecipesexplorer.ColorRecipesExplorerApplication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;

@Service
public class ImagesService {

    private static final String IMAGES_DIRECTORY = "images";

    private FilesService filesService;

    @Autowired
    public ImagesService(FilesService filesService) {
        this.filesService = filesService;
    }

    public byte[] readImage(String name) {
        try {
            return filesService.readFileAsBytes(getPath(name));
        } catch (IOException ex) {
            throw new RuntimeException("Erreur lors de la lecture d'une image: " + ex.getMessage());
        }
    }

    private String getPath(String name) {
        return String.format("%s/%s/%s", ColorRecipesExplorerApplication.UPLOAD_LOCATION, IMAGES_DIRECTORY, name);
    }

}
