package dev.fyloz.trial.colorrecipesexplorer.dao;

import dev.fyloz.trial.colorrecipesexplorer.core.model.Company;
import dev.fyloz.trial.colorrecipesexplorer.core.model.Recipe;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface RecipeDao extends JpaRepository<Recipe, Long> {

    List<Recipe> findAllByCompany(Company company);

    Recipe findByName(String name);

    @Query("select r from Recipe r where upper(r.name) like %?1% or upper(r.description) like %?1%")
    List<Recipe> findAllByRecipeDescriptionContainsOrRecipeCodeContains(String searchWordUpperCase);
}
