package dev.fyloz.trial.colorrecipesexplorer.core.services;

import dev.fyloz.trial.colorrecipesexplorer.core.services.model.MixQuantityService;
import dev.fyloz.trial.colorrecipesexplorer.core.model.Material;
import dev.fyloz.trial.colorrecipesexplorer.dao.MixQuantityDao;
import org.junit.Before;
import org.junit.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.mockito.Spy;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;
import static org.mockito.Mockito.doReturn;

public class MixQuantityServiceTests {

    @Mock
    private MixQuantityDao mixQuantityDao;

    @Spy
    @InjectMocks
    private MixQuantityService mixQuantityService;

    private Material testMaterial;

    @Before
    public void init() {
        MockitoAnnotations.initMocks(this);

        testMaterial = new Material();
        testMaterial.setMaterialID(0);
        testMaterial.setName("Test Material");
    }

    @Test
    public void existsByMaterialTestShouldBeTrue() {
        doReturn(true).when(mixQuantityDao).existsByMaterial(testMaterial);

        boolean actual = mixQuantityService.existsByMaterial(testMaterial);
        assertTrue(actual);
    }

    @Test
    public void existsByMaterialTestShouldBeFalse() {
        doReturn(false).when(mixQuantityDao).existsByMaterial(testMaterial);

        boolean actual = mixQuantityService.existsByMaterial(testMaterial);
        assertFalse(actual);
    }

    @Test
    public void existsByMaterialTestNull() {
        doReturn(false).when(mixQuantityDao).existsByMaterial(testMaterial);

        boolean actual = mixQuantityService.existsByMaterial(null);
        assertFalse(actual);
    }

}
